// dz_utils: append 1.0b-2007-01-03
//
// note: this file is PUBLIC DOMAIN
// feel free to do whatever you want with it

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

// defs.h

typedef long INT32;
typedef short INT16;
typedef char INT8;
typedef unsigned long UINT32;
typedef unsigned short UINT16;
typedef unsigned char UINT8;

#define STR_LENGTH 1024

// append.h

void loadtoc(INT8 *s);
void do_append(INT8 *s, int op);

// global vars

UINT32 gSize, gVer, *gToc;
INT8 gName[STR_LENGTH];

// dowah dowah

void loadtoc(INT8 *s)
{
	int status = 0;
	UINT32 xStart, xSize, xVer, *pToc;
	FILE *f = fopen(s, "rb");

	gToc = NULL;
	if (f != NULL) {
		fseek(f, 0x28, 0);
		fread(&xStart, 4, 1, f);			// !le!
		fread(&xSize, 4, 1, f);				// !le!
		fseek(f, 0x3C, 0);
		fread(&xVer, 4, 1, f);				// subversion (1/2) !le!

		if (xSize != 0) {
			fseek(f, xStart, 0);
			pToc = (UINT32 *) malloc(xSize);
			if (pToc != NULL) {
				fread(pToc, xSize, 1, f);	// load toc
				status = 1;
			}
		}

		strcpy(gName, s);

		if (status) {
			gToc = pToc;
			gSize = xSize;
			gVer = xVer;
		}

		fclose(f);
	}
}

void do_append(INT8 *s, int op)
{
	UINT32 g, t, i, u, x, x2, v, sz, ts, tn;
	FILE *f;
	UINT8 *buf = NULL;

	// get resource info from file name
	if (sscanf(s, "%x-%x-%x-%x", &g, &t, &i, &u) != 4) {
		u = 0;
		if (sscanf(s, "%x-%x-%x", &g, &t, &i) != 3) return;
	}

	// get data
	f = fopen(s, "rb");
	if (f != NULL) {
		fseek(f, 0, SEEK_END);
		sz = ftell(f);
		buf = (UINT8 *) malloc(sz);
		fseek(f, 0, 0);
		fread(buf, sz, 1, f);
		fclose(f);
	}

	// store data
	if (buf != NULL) {
		f = fopen(gName, "rb+");
		if (f != NULL) {
			// get header info
			fseek(f, 0x24, 0);
			fread(&tn, 4, 1, f);		// num of entries in TOC !le!
			fread(&x, 4, 1, f);			// offset of TOC start
			fread(&ts, 4, 1, f);		// size of TOC
			fseek(f, 0x3C, 0);
			fread(&v, 4, 1, f);			// minor ver

			// if new package, index = header size
			if (tn == 0) x = 0x60;

			// store new data
			fseek(f, x, 0);				// x = buffer index
			fwrite(buf, 1, sz, f);
			x2 = ftell(f);				// x2 = new TOC index

			// append TOC
			if (gToc != NULL)
				fwrite(gToc, 1, gSize, f);

			// append new entry to TOC
			tn++;
			ts += 20;
			fwrite(&t, 4, 1, f);		// type
			fwrite(&g, 4, 1, f);		// group
			fwrite(&i, 4, 1, f);		// instance
			if (v > 1) {
				fwrite(&u, 4, 1, f);	// subtype
				ts += 4;
			}
			fwrite(&x, 4, 1, f);		// index
			fwrite(&sz, 4, 1, f);		// size

			// update header
			fseek(f, 0x24, 0);
			fwrite(&tn, 4, 1, f);		// num of entries in TOC
			fwrite(&x2, 4, 1, f);		// offset of TOC start
			fwrite(&ts, 4, 1, f);		// size of TOC

			fclose(f);
		}
		free(buf);
	}
}

int main(int argc, char *argv[])
{
	int it, x = 0, op = 0;
	INT8 *sf = NULL;

	if (argc > 2) {
		for (it = 1; it < argc; it++) {
			if (x == 0) {
				sf = argv[it];
				x = 1;
			} else {
				loadtoc(sf);
				do_append(argv[it], op);
				if (gToc != NULL) free(gToc);
			}
		}
	} else {
		printf("append usage:\n\n");
		printf("append package data [data...]\n\n");
	}
}
