// dz_utils: create 1.0a-2007-01-02
//
// note: this file is PUBLIC DOMAIN
// feel free to do whatever you want with it

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

// defs.h

typedef long INT32;
typedef short INT16;
typedef char INT8;
typedef unsigned long UINT32;
typedef unsigned short UINT16;
typedef unsigned char UINT8;

#define STR_LENGTH 1024

// create.h

void do_create(INT8 *s, int op, UINT32 v);
UINT32 hex2int(INT8 *s);
int opt_parse(INT8 *o, int x);

// dowah dowah

void do_create(INT8 *s, int op, UINT32 v)
{
	UINT8 buf[0x60];
	FILE *f;

	// setup buffer
	memset(buf, 0, 0x60);	// clear
	buf[0] = 'D';
	buf[1] = 'B';
	buf[2] = 'P';
	buf[3] = 'F';
	buf[4] = 1;		// ID
	buf[8] = 1;		// version
	buf[0x20] = 7;	// major ver
	buf[0x3C] = 2;	// minor ver

	// specified ver
	if (op & 1) {
		*(UINT32*) (&buf[0x3C]) = v;	// !le!
	}

	// dump buf -> file
	f =	fopen(s, "wb");
	if (f != NULL) {
		fwrite(buf, 1, 0x60, f);
		fclose(f);
	}
}

UINT32 hex2int(INT8 *s)
{
	INT8 *s2 = s;
	UINT32 v;

	if (strlen(s) > 2) {
		// hexfix?
		if (stricmp(s, "0x") == 0) {
			// ignore
			s2 = s + 2;
		}
	}
	// assume this is hex
	if (sscanf(s2, "%x", &v) == 1)
		return v;
	else
		return 0;
}

int opt_parse(INT8 *o, int x)
{
	if (strcmp(o, "-v") == 0) return 1;
	if (x == 1) return 101;
	return 0;
}

int main(int argc, char *argv[])
{
	UINT32 v;
	int it, x = 0, op = 0;
	INT8 *sf = NULL;

	if (argc > 1) {
		for (it = 1; it < argc; it++) {
			x = opt_parse(argv[it], x);
			if (x == 0) {
				sf = argv[it];
			}
			if (x == 101) {
				v = hex2int(argv[it]);
				op += 1;
			}
		}
		do_create(sf, op, v);
	} else {
		printf("create usage:\n\n");
		printf("create [-v ver] package\n");
		printf("  -v <hexvalue>     TOC minor version (default = 2)\n\n");
	}
	return 0;
}
