// dz_utils: xed 1.0a-2007-01-03
//
// note: this file is PUBLIC DOMAIN
// feel free to do whatever you want with it

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

// defs.h

typedef long INT32;
typedef short INT16;
typedef char INT8;
typedef unsigned long UINT32;
typedef unsigned short UINT16;
typedef unsigned char UINT8;

#define STR_LENGTH 4096

// xed.h

void do_edit(INT8 *s, int ar, int br, int dx, UINT8 *data);
UINT32 hex2int(INT8 *s);
int opt_parse(INT8 *o, int x);

// dowah dowah

void do_edit(INT8 *s, int ar, int br, int dx, UINT8 *data)
{
	FILE *f;
	UINT32 sz;
	UINT8 *buf = NULL;

	f = fopen(s, "rb");
	if (f != NULL) {
		// get old data
		fseek(f, 0, SEEK_END);
		sz = ftell(f);
		buf = (UINT8 *) malloc(sz);
		fseek(f, 0, 0);
		fread(buf, sz, 1, f);
		fclose(f);

		// set range
		if (ar < 0 || ar > sz) ar = sz;
		if (br < 0 || br > sz) br = sz;

		// store data
		f = fopen(s, "wb");
		if (f != NULL) {
			if (ar > 0) fwrite(buf, 1, ar, f);
			if (dx > 0) fwrite(data, 1, dx, f);
			if (br < sz) fwrite(&buf[br], 1, (sz-br), f);
			fclose(f);
		}
	}
}

UINT32 hex2int(INT8 *s)
{
	INT8 *s2 = s;
	UINT32 v;

	if (strlen(s) > 2) {
		// hexfix?
		if (stricmp(s, "0x") == 0) {
			// ignore
			s2 = s + 2;
		}
	}
	// assume this is hex
	if (sscanf(s2, "%x", &v) == 1)
		return v;
	else
		return 0;
}

int opt_parse(INT8 *o, int x)
{
	if (strcmp(o, "-r") == 0) return 1;
	if (strcmp(o, "-d") == 0) return 2;
	if (strcmp(o, "-D") == 0) return 3;
	if (x == 1) return 101;
	if (x == 101) return 201;
	if (x == 2 || x == 102) return 102;
	return 0;
}

int main(int argc, char *argv[])
{
	int it, x = 0, ar = -1, br = -1, dx = 0;
	INT8 *sf = NULL;
	UINT32 i;
	UINT8 data[STR_LENGTH];

	if (argc > 1) {
		for (it = 1; it < argc; it++) {
			x = opt_parse(argv[it], x);
			if (x == 0) {
				sf = argv[it];
			}
			if (x == 101) {
				ar = (int) hex2int(argv[it]);
			}
			if (x == 201) {
				br = (int) hex2int(argv[it]);
			}
			if (x == 102) {
				i = hex2int(argv[it]);
				data[dx++] = (i & 0xFF);
				if (dx >= STR_LENGTH) dx = STR_LENGTH - 1;
			}
		}
		do_edit(sf, ar, br, dx, data);
	} else {
		printf("xed usage:\n\n");
		printf("xed [-r start [end+1]] [-d value [value...] -D] file\n");
		printf("  -r <hexvalue> [<hexvalue>]  select index range (default = EOF EOF)\n");
		printf("  -d <hexvalue...>            data list to replace range\n");
		printf("  -D                          end of data list\n\n");
		printf("for example:\n");
		printf("  xed -d 17 A4 32 01 -D FFFFFFFF-0x42484156-00001043.dat\n");
		printf("  xed -r 4E 58 FFFFFFFF-42434F4E-00001002.dat\n");
		printf("  xed -r 0 -d 0 -D FFFFFFFF-42434F4E-00001002.dat\n");
		printf("  xed -r 0 0 -d 12 5A 7D 8E 44 -D 7FD46CD0-42434F4E-00000106.dat\n\n");
	}
	return 0;
}
